class VideoVclPlayer {
  // ...

  playVLC(fileName) {
    console.log("播放 VLC 视频：", fileName);
  }
}

// MP4 播放器
class VideoMp4Player {
  // ...

  playMp4(fileName) {
    console.log("播放 MP4 视频：", fileName);
  }
}

class MPEGPlayer {
  // ...

  playMpeg(fileName) {
    console.log("播放 MPEG 视频：", fileName);
  }
}

class MediaAdapter {
  // ...

  // 通过类型字段 type 判断
  play(type, fileName) {
    if (type === "VLC") {
      // 构建 vlc 实例
      const vlc = new VideoVclPlayer();
      vlc.playVLC(fileName);
    } else if (type === "MP4") {
      // 构建 mp4 实例
      const mp4 = new VideoMp4Player();
      mp4.playMp4(fileName);
    } else if (type === "MPEG") {
        // 构建 mpeg 实例
      const mpeg = new MPEGPlayer();
      mpeg.playMpeg(fileName);
    }
  }
}

// 这里需要注释掉原 AudioPlayer 类
class AudioPlayer extends MediaAdapter {
  constructor() {
    super(); // 这是 ES6 中 class 的内容
  }

  play(type, fileName) {
    if (type === "MP3") {
      console.log("播放 MP3 音乐：", fileName);
    } else if (type === "VLC" || type === "MP4" || type === "MPEG") {
      super.play(type, fileName); // 调用继承类的方法
    } else {
      console.log("不支持该格式！");
    }
  }
}

// 通过原产品构建 audioPlayer 播放器实例
const audioPlayer = new AudioPlayer();

// 分别调用各种格式的内容
audioPlayer.play("MP3", "千里之外"); // 播放 MP3 音乐： 千里之外
audioPlayer.play("VLC", "哪吒闹海"); // 播放 VLC 视频： 哪吒闹海
audioPlayer.play("MP4", "大闹天宫"); // 播放 MP4 视频： 大闹天宫
audioPlayer.play("MPEG", "MPEG 新格式视频"); // 播放 MPEG 视频： MPEG 新格式视频
audioPlayer.play("JPG", ""); // 不支持该格式！
