// MP3 播放器
// class AudioPlayer {
//   // ...

//   play(fileName) {
//     console.log("播放 MP3 音乐：", fileName);
//   }
// }

// 构建一个 audioPlayer 实例
// const audioPlayer = new AudioPlayer();

// 调用 play，播放 MP3
// audioPlayer.play("千里之外"); // 播放 MP3 音乐： 千里之外

// VLC 播放器
class VideoVclPlayer {
  // ...

  playVLC(fileName) {
    console.log("播放 VLC 视频：", fileName);
  }
}

// MP4 播放器
class VideoMp4Player {
  // ...

  playMp4(fileName) {
    console.log("播放 MP4 视频：", fileName);
  }
}

// 构建一个 audioPlayer 实例
// const vlc = new VideoVclPlayer();

// 调用 playVLC，播放 VLC
// vlc.playVLC("哪吒闹海"); // 播放 VLC 视频： 哪吒闹海

// 构建一个 audioPlayer 实例
// const mp4 = new VideoMp4Player();

// 调用 playMp4，播放 MP4
// mp4.playMp4("大闹天宫"); // 播放 MP4 视频： 大闹天宫

// 视频的适配器
class MediaAdapter {
  // ...

  // 通过类型字段 type 判断
  play(type, fileName) {
    if (type === "VLC") {
      // 构建 vlc 实例
      const vlc = new VideoVclPlayer();
      vlc.playVLC(fileName);
    } else if (type === "MP4") {
      // 构建 mp4 实例
      const mp4 = new VideoMp4Player();
      mp4.playMp4(fileName);
    }
  }
}

// 这里需要注释掉原 AudioPlayer 类
class AudioPlayer extends MediaAdapter {
  constructor() {
    super(); // 这是 ES6 中 class 的内容
  }

  play(type, fileName) {
    if (type === "MP3") {
      console.log("播放 MP3 音乐：", fileName);
    } else if (type === "VLC" || type === "MP4") {
      super.play(type, fileName); // 调用继承类的方法
    } else {
      console.log("不支持该格式！");
    }
  }
}

// 通过原产品构建 audioPlayer 播放器实例
const audioPlayer = new AudioPlayer();

// 分别调用各种格式的内容
audioPlayer.play("MP3", "千里之外"); // 播放 MP3 音乐： 千里之外
audioPlayer.play("VLC", "哪吒闹海"); // 播放 VLC 视频： 哪吒闹海
audioPlayer.play("MP4", "大闹天宫"); // 播放 MP4 视频： 大闹天宫
audioPlayer.play("JPG", ""); // 不支持该格式！

